define( () =>
{
class Control
{
	static m_oStyleSheetPromise;
	static m_fnMouseDown = e => !e.target.closest( "DETAILS.clsPopup[open]" ) && document.querySelectorAll( "DETAILS:not(.clsModelessDetail)" ).forEach( el => el.open = false ); // eslint-disable-line no-return-assign

	static initModule()
	{
		const d = document;
		const v_elLink = d.createElement( "LINK" );
		v_elLink.setAttribute( "rel", "stylesheet" );
		this.m_oStyleSheetPromise = new Promise( fnResolve => v_elLink.onload = fnResolve ); // eslint-disable-line no-return-assign, no-promise-executor-return
		v_elLink.setAttribute( "href", "../v1/ext/Native_Custom_Control_Popup/Popup.css" );
		d.querySelector( "HEAD" ).appendChild( v_elLink );
		d.body.addEventListener( "mousedown", this.m_fnMouseDown, true );
	}

	initialize = () => Control.m_oStyleSheetPromise;

	draw( oControlHost )
	{
		const oConfig = oControlHost.configuration ?? {};
		const divPopupBlock = oControlHost.container.closest( 'DIV[specname="block"]' );
		if ( !divPopupBlock )
		{
			throw new scriptableReportError( "Popup", "draw", "The popup control must be located inside the block to popup." );
		}
		if ( divPopupBlock.style.display !== "none" )
		{
			throw new scriptableReportError( "Popup", "draw", 'The block to popup must have "Box type" set to "None-Block".' );
		}
		const elDetails = document.createElement( "DETAILS" );
		elDetails.className = `clsPopup${oConfig.Modeless ? " clsModelessDetail" : ""}`;
		const sPadding = oConfig.Label ? "" : "padding:0;";
		const sColor = oConfig.Color ? `color:${oConfig.Color};` : "";
		const sLabel = oConfig.Label ? '<DIV class="clsPopupLabel"></DIV>' : "";
		const sIcon = oConfig["SVG Icon"] ?? "";
		elDetails.innerHTML = `<SUMMARY class="clsPopup" style="${sColor}${sPadding}">${sIcon}${sLabel}</SUMMARY><DIV class="clsDetailPopup"></DIV>`;
		if ( oConfig.Label )
		{
			elDetails.querySelector( ".clsPopupLabel" ).textContent = oConfig.Label;
		}
		if ( oConfig.Tooltip )
		{
			elDetails.querySelector( "SUMMARY" ).title = oConfig.Tooltip;
		}
		divPopupBlock.replaceWith( elDetails );
		elDetails.querySelector( "DIV.clsDetailPopup" ).append( divPopupBlock );
		divPopupBlock.style.display = "";
	}
}
Control.initModule();
return Control;
} );
