define( () =>
{
class CustomDesignControl
{
	static f_htmlEncode = s => s.replace( /&/g, "&amp;" ).replace( /</g, "&lt;" ).replace( />/g, "&gt;" );

	static initialization =
	{
		configuration:
		{
			"Label": "Popup Label",
			"Tooltip": "",
			"SVG Icon": "",
			"Color": "",
			/*"Hover color": "",*/
			"Modeless": false
		},
		path: "../v1/ext/Native_Custom_Control_Popup/Popup",
	};

	static configOptions =
	{
		allowJsonEdit: false,
		topLevelProperties:
		{
			"Label":
			{
				tooltip: "The label to display beside the icon"
			},
			"Tooltip":
			{
				tooltip: "The tooltip displayed when hvoering over the label or icon"
			},
			"SVG Icon":
			{
				tooltip: "The icon to display beside the label. This must be valid SVG."
			},
			"Color":
			{
				type: "color",
				tooltip: "The foreground color"
			},
			/*"Hover color":
			{
				type: "color",
				tooltip: "The foreground color used when hovering"
			},*/
			"Modeless":
			{
				tooltip: "If not enabled, the popup will be dismissed when clicking anywhere else in the report."
			}
		}
	};


	static properties =
	{
		visibility:
		{
			show: ["ccConfiguration"]
		},
		labels:
		{
			ccConfiguration: "Options"
		},
		descriptions:
		{
			ccConfiguration: "Popup options"
		}
	};

	static dataSets =
	{
		limits:
		{
			max: 0
		}
	};

	static toolboxLocation =
	{
		group:
		{
			id: "toolboxLayoutLabel",
			location: "first"
		}
	};

	static draw( nCustomControl )
	{
		const oConfig = JSON.parse( nCustomControl.querySelector( "configuration" ).textContent );
		const sPadding = oConfig.Label ? "" : "padding:0;";
		const sColor = oConfig.Color ? `color:${oConfig.Color};` : "";
		const sLabel = oConfig.Label ? `<DIV class="clsPopupLabel">${this.f_htmlEncode(oConfig.Label)}</DIV>` : "";
		const sIcon = oConfig["SVG Icon"];
		return `<DETAILS class="clsPopup"><SUMMARY class="clsPopup" style="${sColor}${sPadding}">${sIcon}${sLabel}</SUMMARY></DETAILS>`;
	}

	static drawConfiguration( nCustomControl, sConfiguration )
	{
		return "(Defined)";
	}

	static initModule()
	{
		const v_elLink = document.createElement( "LINK" );
		v_elLink.setAttribute( "rel", "stylesheet" );
		v_elLink.setAttribute( "href", "../v1/ext/Native_Custom_Control_Popup/Popup.css" );
		document.querySelector( "HEAD" ).appendChild( v_elLink );
	}
}
CustomDesignControl.initModule();

return CustomDesignControl;
} );
